/***********************************************************************************************************/
/**********************************************************IXML.js******************************************/
/***********************************************************************************************************/
/*!
* ====================================================================
 * About
 * ====================================================================
 * Sarissa cross browser XML library - IE XPath Emulation 
 * @version @project.version@
 * @author: Manos Batsis, mailto: mbatsis at users full stop sourceforge full stop net
 *
 * This script emulates Internet Explorer's selectNodes and selectSingleNode
 * for Mozilla. Associating namespace prefixes with URIs for your XPath queries
 * is easy with IE's setProperty. 
 * USers may also map a namespace prefix to a default (unprefixed) namespace in the
 * source document with Sarissa.setXpathNamespaces
 *
 *
 * ====================================================================
 * Licence
 * ====================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 or
 * the GNU Lesser General Public License version 2.1 as published by
 * the Free Software Foundation (your choice of the two).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License or GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * or GNU Lesser General Public License along with this program; if not,
 * write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * or visit http://www.gnu.org
 *
 */
/**
*@class
Class Summary
XMLDOM <p>
XMLHttpRequest<i></i><p>
XSLTProcessor<p>
XMLSerializer<p>

* ====================================================================
 * About
 * ====================================================================
 * Sarissa cross browser XML library - IE XPath Emulation 
 * @version @project.version@
 * @author: Manos Batsis, mailto: mbatsis at users full stop sourceforge full stop net
 *
 * This script emulates Internet Explorer's selectNodes and selectSingleNode
 * for Mozilla. Associating namespace prefixes with URIs for your XPath queries
 * is easy with IE's setProperty. 
 * USers may also map a namespace prefix to a default (unprefixed) namespace in the
 * source document with Sarissa.setXpathNamespaces
 *
 *
 * ====================================================================
 * Licence
 * ====================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 or
 * the GNU Lesser General Public License version 2.1 as published by
 * the Free Software Foundation (your choice of the two).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License or GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * or GNU Lesser General Public License along with this program; if not,
 * write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * or visit http://www.gnu.org
 *
 */

function IXML(){};
IXML.PARSED_OK = "Document contains no parsing errors";
IXML.PARSED_EMPTY = "Document is empty";
IXML.PARSED_UNKNOWN_ERROR = "Not well-formed or other error";
IXML.IS_ENABLED_XMLHTTP = false;
IXML.IS_ENABLED_SELECT_NODES = false;
var _IXML_iNsCounter = 0;

var _IXML_IEPREFIX4XSLPARAM = "";
var _IXML_HAS_DOM_IMPLEMENTATION = document.implementation && true;
var _IXML_HAS_DOM_CREATE_DOCUMENT = _IXML_HAS_DOM_IMPLEMENTATION && document.implementation.createDocument;
var _IXML_HAS_DOM_FEATURE = _IXML_HAS_DOM_IMPLEMENTATION && document.implementation.hasFeature;
var _IXML_IS_MOZ = _IXML_HAS_DOM_CREATE_DOCUMENT && _IXML_HAS_DOM_FEATURE;
var _IXML_IS_SAFARI = (navigator.userAgent && navigator.vendor && (navigator.userAgent.toLowerCase().indexOf("applewebkit") != -1 || navigator.vendor.indexOf("Apple") != -1));
var _IXML_IS_IE = document.all && window.ActiveXObject && navigator.userAgent.toLowerCase().indexOf("msie") > -1  && navigator.userAgent.toLowerCase().indexOf("opera") == -1;
if(!window.Node || !window.Node.ELEMENT_NODE){
var Node = {ELEMENT_NODE: 1, ATTRIBUTE_NODE: 2, TEXT_NODE: 3, CDATA_SECTION_NODE: 4, ENTITY_REFERENCE_NODE: 5,               ENTITY_NODE: 6, PROCESSING_INSTRUCTION_NODE: 7, COMMENT_NODE: 8, DOCUMENT_NODE: 9,DOCUMENT_TYPE_NODE: 10,     DOCUMENT_FRAGMENT_NODE: 11, NOTATION_NODE: 12};
};


// IE initialization
if(_IXML_IS_IE){
     // for XSLT parameter names, prefix needed by IE
     _IXML_IEPREFIX4XSLPARAM = "xsl:";
     // used to store the most recent ProgID available out of the above
     var _IXML_DOM_PROGID = "";
     var _IXML_XMLHTTP_PROGID = "";

         IXML.pickRecentProgID = function (idList, enabledList){
        // found progID flag
        var bFound = false;
        for(var i=0; i < idList.length && !bFound; i++){
            try{
                var oDoc = new ActiveXObject(idList[i]);
                o2Store = idList[i];
                bFound = true;
                for(var j=0;j<enabledList.length;j++)
                    if(i <= enabledList[j][1])
                        IXML["IS_ENABLED_"+enabledList[j][0]] = true;
               }catch (objException){
                // trap; try next progID
               };
        };
        if (!bFound)
            throw "Could not retreive a valid progID of Class: " + idList[idList.length-1] +
                        ". (original exception: "+e+")";
            idList = null;
           return o2Store;
    };

  IXML.pickRecentProgID = function (idList){
        // found progID flag
        var bFound = false;
        for(var i=0; i < idList.length && !bFound; i++){
            try{
                var oDoc = new ActiveXObject(idList[i]);
                o2Store = idList[i];
                bFound = true;
            }catch (objException){
                // trap; try next progID
            };
        };
        if (!bFound) {
            throw "Could not retreive a valid progID of Class: " + idList[idList.length-1]+". (original exception: "+e+")";
        };
        idList = null;
        return o2Store;
    };
    // pick best available MSXML progIDs
    _IXML_DOM_PROGID = null;
    _IXML_THREADEDDOM_PROGID = null;
    _IXML_XSLTEMPLATE_PROGID = null;
    _IXML_XMLHTTP_PROGID = null;




      if(!window.XMLHttpRequest){
			if(!_IXML_XMLHTTP_PROGID){
						_IXML_XMLHTTP_PROGID =IXML.pickRecentProgID(["Msxml2.XMLHTTP.5.0", "Msxml2.XMLHTTP.4.0", "MSXML2.XMLHTTP.3.0",    "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"]);
			};

             XMLHttpRequest = function() {

                           if(!_IXML_XMLHTTP_PROGID){
                              _IXML_XMLHTTP_PROGID = IXML.pickRecentProgID(["Msxml2.XMLHTTP.5.0", "Msxml2.XMLHTTP.4.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"]);
                            };

                           return new ActiveXObject(_IXML_XMLHTTP_PROGID);
             }

          }

         IXML.getDomDocument = function(sUri, sName){
             if(!_IXML_DOM_PROGID){
            _IXML_DOM_PROGID =IXML.pickRecentProgID(["Msxml2.DOMDocument.6.0","Msxml2.DOMDocument.5.0", "Msxml2.DOMDocument.4.0", "Msxml2.DOMDocument.3.0", "MSXML2.DOMDocument", "MSXML.DOMDocument", "Microsoft.XMLDOM"]);
        };

                 var oDoc = new ActiveXObject(_IXML_DOM_PROGID);
				 try{
                   if(_IXML_DOM_PROGID=="MSXML3.DOMDocument" || _IXML_DOM_PROGID=="MSXML2.DOMDocument" || _IXML_DOM_PROGID=="MSXML.DOMDocument" || _IXML_DOM_PROGID=="Microsoft.XMLDOM")
                      oDoc.setProperty('SelectionLanguage', 'XPath');
                 }catch(e){
                 };
        // if a root tag name was provided, we need to load it in the DOM object
          if (sName){
            // create an artifical namespace prefix
            // or reuse existing prefix if applicable
            var prefix = "";
            if(sUri){
                if(sName.indexOf(":") > 1){
                    prefix = sName.substring(0, sName.indexOf(":"));
                    sName = sName.substring(sName.indexOf(":")+1);
                }else{
                    prefix = "a" + (_IXML_iNsCounter++);
                };
            };
            // use namespaces if a namespace URI exists
            if(sUri){
                oDoc.loadXML('<' + prefix+':'+sName + " xmlns:" + prefix + "=\"" + sUri + "\"" + " />");
            } else {
                oDoc.loadXML('<' + sName + " />");
            };
         };
        return oDoc;

        };

        if(!document.importNode){

            try{
                        /**
                        * Implementation of importNode for the context window document in IE
                        * @param oNode the Node to import
                        * @param bChildren whether to include the children of oNode
                        * @returns the imported node for further use
                        */
            document.importNode = function(oNode, bChildren){
            var tmp = document.createElement("div");
            if(bChildren){
                tmp.innerHTML = oNode.xml ? oNode.xml : oNode.innerHTML;
            }else{
                tmp.innerHTML = oNode.xml ? oNode.cloneNode(false).xml : oNode.cloneNode(false).innerHTML;
            };
            return tmp.getElementsByTagName("*")[0];
        };
        }catch(e){ };

        }

        IXML.getParseErrorText = function (oDoc) {
        var parseErrorText = IXML.PARSED_OK;
        if(oDoc.parseError && oDoc.parseError.errorCode != 0){
            parseErrorText = "XML Parsing Error: " + oDoc.parseError.reason +
                "\nLocation: " + oDoc.parseError.url +
                "\nLine Number " + oDoc.parseError.line + ", Column " +
                oDoc.parseError.linepos +
                ":\n" + oDoc.parseError.srcText +
                "\n";
            for(var i = 0;  i < oDoc.parseError.linepos;i++){
                parseErrorText += "-";
            };
            parseErrorText +=  "^\n";
        }
        else if(oDoc.documentElement == null){
            parseErrorText = IXML.PARSED_EMPTY;
        };
        return parseErrorText;
    };

         XSLTProcessor = function(){
        if(!_IXML_XSLTEMPLATE_PROGID){
            _IXML_XSLTEMPLATE_PROGID = IXML.pickRecentProgID(["Msxml2.XSLTemplate.6.0","Msxml2.XSLTemplate.5.0", "Msxml2.XSLTemplate.4.0", "MSXML2.XSLTemplate.3.0"]);
        };
                this.template = new ActiveXObject(_IXML_XSLTEMPLATE_PROGID);
                this.processor = null;

    };
     XSLTProcessor.prototype.importStylesheet = function(xslDoc,bool){
        // convert stylesheet to free threaded
      if(!_IXML_THREADEDDOM_PROGID){
            _IXML_THREADEDDOM_PROGID = IXML.pickRecentProgID(["Msxml2.FreeThreadedDOMDocument.6.0","Msxml2.FreeThreadedDOMDocument.5.0", "MSXML2.FreeThreadedDOMDocument.4.0", "MSXML2.FreeThreadedDOMDocument.3.0"]);
            _IXML_DOM_XMLWRITER = IXML.pickRecentProgID(["Msxml2.MXXMLWriter.6.0","Msxml2.MXXMLWriter.5.0", "Msxml2.MXXMLWriter.4.0", "Msxml2.MXXMLWriter.3.0", "MSXML2.MXXMLWriter", "MSXML.MXXMLWriter", "Microsoft.XMLDOM"]);
        };

            var converted = new ActiveXObject(_IXML_THREADEDDOM_PROGID);
           if(bool){

              var arr_paramName=(arguments[2])?arguments[2]:null;
              var arr_paramValue=(arguments[3])?arguments[3]:null;
              var container=(arguments[4])?arguments[4]:null;
              var xmldoc=(arguments[5])?arguments[5]:null;

              converted.onreadystatechange=function(){if(converted.readyState == 4){var _this =  XSLTProcessor.prototype;_this.createProcessor(converted,arr_paramName,arr_paramValue,container,xmldoc)}};
               /*
              if(xslDoc.url){
                  converted.load(xslDoc.url);
              } else {
                    converted.loadXML(xslDoc.xml);
              };
*/
              converted.loadXML(xslDoc.xml);


           }
           else{


                converted.async = bool;
               /*if(xslDoc.url){
                  converted.load(xslDoc.url);
                } else {
                    converted.loadXML(xslDoc.xml);
                };*/
                 converted.loadXML(xslDoc.xml);

               converted.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'");
               var output = converted.selectSingleNode("//xsl:output");
               this.outputMethod = output ? output.getAttribute("method") : "html";
               this.template.stylesheet = converted;
               this.processor = this.template.createProcessor();
               this.paramsSet = new Array();


           }



    };



    XSLTProcessor.prototype.createProcessor=function(converted)
      {
               converted.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'");
               var output = converted.selectSingleNode("//xsl:output");
               this.outputMethod = output ? output.getAttribute("method") : "html";
               if(null==this.template) this.template = new ActiveXObject(_IXML_XSLTEMPLATE_PROGID);
               this.template.stylesheet = converted;
               this.processor = this.template.createProcessor();
               this.paramsSet = new Array();
               if(arguments[1]&& arguments[2] && arguments[1]!="" && arguments[2]!="")
                 {
                   for(var i=0;i<arguments[1].length;i++)
                       this.setParameter("",arguments[1][i],arguments[2][i]);
                 }

               if(arguments[3] && arguments[4])
                {
                  arguments[3].innerHTML =  IXML.serialize(this.transformToDocument(arguments[4]))
                }


      };

         /**
     * Transform the given XML DOM and return the transformation result as a new DOM document
     * @argument sourceDoc The XML DOMDocument to transform
     * @return The transformation result as a DOM Document
     */
    XSLTProcessor.prototype.transformToDocument = function(sourceDoc){
        this.processor.input = sourceDoc;
        var outDoc = new ActiveXObject(_IXML_DOM_XMLWRITER);
        this.processor.output = outDoc;
        this.processor.transform();
        var oDoc = new ActiveXObject(_IXML_DOM_PROGID);
        oDoc.loadXML(outDoc.output+"");
        return oDoc;
    };
        /**
     * Set global XSLT parameter of the imported stylesheet
     * @argument nsURI The parameter namespace URI
     * @argument name The parameter base name
     * @argument value The new parameter value
     */
    XSLTProcessor.prototype.setParameter = function(nsURI, name, value){
        /* nsURI is optional but cannot be null */
        if(nsURI){
            this.processor.addParameter(name, value, nsURI);
        }else{
            this.processor.addParameter(name, value);
        };
        /* update updated params for getParameter */
        if(!this.paramsSet[""+nsURI]){
            this.paramsSet[""+nsURI] = new Array();
        };
        this.paramsSet[""+nsURI][name] = value;
    };
    /**
     * Gets a parameter if previously set by setParameter. Returns null
     * otherwise
     * @argument name The parameter base name
     * @argument value The new parameter value
     * @return The parameter value if reviously set by setParameter, null otherwise
     */
    XSLTProcessor.prototype.getParameter = function(nsURI, name){
        nsURI = nsURI || "";
        if(this.paramsSet[nsURI] && this.paramsSet[nsURI][name]){
            return this.paramsSet[nsURI][name];
        }else{
            return null;
        };
    };


        IXML.transformNode=function(xmlDoc,style){
           var xslDoc = new ActiveXObject(_IXML_DOM_PROGID);
            xslDoc.async = false;
        xslDoc.load(style);
                return xmlDoc.transformNode(xslDoc);

        }




}else{ /* end IE initialization, try to deal with real browsers now ;-) */

 if(_IXML_HAS_DOM_CREATE_DOCUMENT){
        /**
         * <p>Ensures the document was loaded correctly, otherwise sets the
         * parseError to -1 to indicate something went wrong. Internal use</p>
         * @private
         */
        IXML.__handleLoad__ = function(oDoc){
            IXML.__setReadyState__(oDoc, 4);
        };
        /**
        * <p>Attached by an event handler to the load event. Internal use.</p>
        * @private
        */
        _IXML_XMLDocument_onload = function(){
            IXML.__handleLoad__(this);
        };
        /**
         * <p>Sets the readyState property of the given DOM Document object.
         * Internal use.</p>
         * @private
         * @argument oDoc the DOM Document object to fire the
         *          readystatechange event
         * @argument iReadyState the number to change the readystate property to
         */
        IXML.__setReadyState__ = function(oDoc, iReadyState){
            oDoc.readyState = iReadyState;
            oDoc.readystate = iReadyState;
            if (oDoc.onreadystatechange != null && typeof oDoc.onreadystatechange == "function")
                oDoc.onreadystatechange();
        };
        IXML.getDomDocument = function(sUri, sName){
            var oDoc = document.implementation.createDocument(sUri?sUri:null, sName?sName:null, null);
            if(!oDoc.onreadystatechange){

                /**
                * <p>Emulate IE's onreadystatechange attribute</p>
                */
                oDoc.onreadystatechange = null;
            };
            if(!oDoc.readyState){
                /**
                * <p>Emulates IE's readyState property, which always gives an integer from 0 to 4:</p>
                * <ul><li>1 == LOADING,</li>
                * <li>2 == LOADED,</li>
                * <li>3 == INTERACTIVE,</li>
                * <li>4 == COMPLETED</li></ul>
                */
                oDoc.readyState = 0;
            };
            oDoc.addEventListener("load", _IXML_XMLDocument_onload, false);
            return oDoc;
        };
        if(window.XMLDocument){

                                  /**
                            * <p>Keeps a handle to the original load() method. Internal use and only
                            * if Mozilla version is lower than 1.4</p>
                            * @private
                            */
            XMLDocument.prototype._IXML_load = XMLDocument.prototype.load;
                        // NOTE: setting async to false will only work with documents
            // called over HTTP (meaning a server), not the local file system,
            // unless you are using Moz 1.4+.

            /**
                            * <p>This is deprecated, use XMLHttpRequest to load remote documents instead.
                            * Overrides the original load method to provide synchronous loading for
                            * Mozilla versions prior to 1.4 and fix ready state stuff.</p>
                            * @deprecated
                            * @returns the DOM Object as it was before the load() call (may be  empty)
                            */
            XMLDocument.prototype.load = function(sURI) {
                var oDoc = IXML.getDomDocument();
                IXML.copyChildNodes(this, oDoc);
                //oDoc.parseError.errorCode = 0;
                IXML.__setReadyState__(this, 1);
                try {
                    if(this.async == false ) {
                        var tmp = new XMLHttpRequest();
                        tmp.overrideMimeType("text/xml");
                        tmp.open("GET", sURI, false);
                        tmp.send(null);
                        IXML.__setReadyState__(this, 2);
						if(null==tmp.responseXML || null==IXML.getChildElement(tmp.responseXML))
						 {
							
                            var xml =  IXML.getDomDocument();
                            xml = (new DOMParser()).parseFromString(tmp.responseText, "text/xml");
                            IXML.copyChildNodes(xml, this);
						 }
						else
                           IXML.copyChildNodes(tmp.responseXML, this);
                          // Util.writeToTextArea(tmp.responseText);
                        IXML.__setReadyState__(this, 3);
                    }else{
                        this._IXML_load(sURI);
                    };
                }
                catch (objException) {
                        oDoc.parseError.errorCode = -1;
                }
                finally {
                    if (!oDoc.documentElement || oDoc.documentElement.tagName == "parsererror"){
                        //oDoc.parseError.errorCode = -1;
                    };
                    if(this.async == false){
                        IXML.__handleLoad__(this);
                    };
                };
                return oDoc;
            };



        //if(window.XMLDocument) , now mainly for opera
        }// TODO: check if the new document has content before trying to copynodes, check  for error handling in DOM 3 LS
        else if(document.implementation && document.implementation.hasFeature && document.implementation.hasFeature('LS','.0')){

            /**
            * <p>Factory method to obtain a new DOM Document object</p>
            * @argument sUri the namespace of the root node (if any)
            * @argument sUri the local name of the root node (if any)
            * @returns a new DOM Document
            */
            IXML.getDomDocument = function(sUri, sName){
                var oDoc = document.implementation.createDocument(sUri?sUri:null, sName?sName:null, null);
                return oDoc;
            };
        }
        else {
            IXML.getDomDocument = function(sUri, sName){
                var oDoc = document.implementation.createDocument(sUri?sUri:null, sName?sName:null, null);
                // looks like safari does not create the root element for some unknown reason
                if(oDoc && (sUri || sName) && !oDoc.documentElement){
                    oDoc.appendChild(oDoc.createElementNS(sUri, sName));
                };
                return oDoc;
            };
        };

         if(!IXML.IS_ENABLED_TRANSFORM_NODE && window.XSLTProcessor){


           /**
     </b>Extends the Element class to emulate IE's transformNodeToObject (deprecated).
     * <b>Note </b>: The transformation result <i>must </i> be well formed,
     * otherwise an error will be thrown</p>
     * @uses Mozilla's XSLTProcessor
     * @deprecated use the XSLTProcessor instead
     * @argument xslDoc The stylesheet to use (a DOM Document instance)
     * @argument oResult The Document to store the transformation result
     */
    Element.prototype.transformNodeToObject = function(xslDoc, oResult){
        var oDoc = document.implementation.createDocument("", "", null);
        IXML.copyChildNodes(this, oDoc);
        oDoc.transformNodeToObject(xslDoc, oResult);
    };
    /**
       Extends the Document class to emulate IE's transformNodeToObject (deprecated).
     * @uses Mozilla's XSLTProcessor
     * @deprecated use the XSLTProcessor instead
     * @argument xslDoc The stylesheet to use (a DOM Document instance)
     * @argument oResult The Document to store the transformation result
     * @throws Errors that try to be informative
     */
    Document.prototype.transformNodeToObject = function(xslDoc, oResult){
        var xsltProcessor = null;
        try{
            xsltProcessor = new XSLTProcessor();
            if(xsltProcessor.reset){
                /* new nsIXSLTProcessor is available */
                xsltProcessor.importStylesheet(xslDoc);
                var newFragment = xsltProcessor.transformToFragment(this, oResult);
                IXML.copyChildNodes(newFragment, oResult);
            }else{
                /* only nsIXSLTProcessorObsolete is available */
                xsltProcessor.transformDocument(this, xslDoc, oResult, null);
            };
        }catch(e){
            if(xslDoc && oResult)
                throw "Failed to transform document. (original exception: "+e+")";
            else if(!xslDoc)
                throw "No Stylesheet Document was provided. (original exception: "+e+")";
            else if(!oResult)
                throw "No Result Document was provided. (original exception: "+e+")";
            else if(xsltProcessor == null)
                throw "Could not instantiate an XSLTProcessor object. (original exception: "+e+")";
            else
                throw e;

                                alert(e);
        };
    };
               /**
             Extends the Element class to emulate IE's transformNode (deprecated). </p>
             * <p><b>Note </b>: The result of your transformation must be well formed,
             * otherwise you will get an error</p>.
             * @uses Mozilla's XSLTProcessor
             * @deprecated use the XSLTProcessor instead
             * @argument xslDoc The stylesheet to use (a DOM Document instance)
             * @returns the result of the transformation serialized to an XML String
             */
            Element.prototype.transformNode = function(xslDoc){
                var oDoc = document.implementation.createDocument("", "", null);
                IXML.copyChildNodes(this, oDoc);
                return oDoc.transformNode(xslDoc);
            };
            /**
              Extends the Document class to emulate IE's transformNode (deprecated).</p>
             * <p><b>Note </b>: The result of your transformation must be well formed,
             * otherwise you will get an error</p>
             * @uses Mozilla's XSLTProcessor
             * @deprecated use the XSLTProcessor instead
             * @argument xslDoc The stylesheet to use (a DOM Document instance)
             * @returns the result of the transformation serialized to an XML String
             */
            Document.prototype.transformNode = function(xslDoc){
                var out = document.implementation.createDocument("", "", null);
                this.transformNodeToObject(xslDoc, out);
                var str = null;
                try{
                    var serializer = new XMLSerializer();
                    str = serializer.serializeToString(out);
                }catch(e){
                    throw "Failed to serialize result document. (original exception: "+e+")";
                };
                return str;
            };
              IXML.IS_ENABLED_TRANSFORM_NODE = true;
       };

    };//if(_IXML_HAS_DOM_CREATE_DOCUMENT)
};


 //==========================================
// Common stuff
//==========================================

IXML.getText = function(oNode, deep){
    if(oNode==null)return;
    var s = "";
    var nodes = oNode.childNodes;
    for(var i=0; i < nodes.length; i++){
        var node = nodes[i];
        var nodeType = node.nodeType;
        if(nodeType == Node.TEXT_NODE || nodeType == Node.CDATA_SECTION_NODE){
            s += node.data;
        }else if(deep == true
                    && (nodeType == Node.ELEMENT_NODE
                        || nodeType == Node.DOCUMENT_NODE
                        || nodeType == Node.DOCUMENT_FRAGMENT_NODE)){
            s += IXML.getText(node, true);
        };
    };
    return s;
};

IXML.setText=function(oNode,text){
    if(oNode==null || text==null)return;
	var nodes = oNode.childNodes;
	if(nodes.length==0 && oNode.nodeType==Node.ELEMENT_NODE){
	   
       if(!_IXML_IS_IE){
         var elementNode = document.createElement("NODE");
         var textNode = document.createTextNode(text);
         elementNode.appendChild(textNode);
         IXML.copyChildNodes(elementNode,oNode,false);
         textNode=null;
         elementNode=null;
       }
       else
           oNode.text=text;
     }
	else{
	    for(var i=0; i < nodes.length; i++){
		    var node = nodes[i];
            var nodeType = node.nodeType;
		    if(nodeType == Node.TEXT_NODE || nodeType == Node.CDATA_SECTION_NODE){
			   node.data = text;
			   return;
		    };
	     };
	 }
};

IXML.setInnerText=function(html_control,text)
{
   var hasInnerText = (document.getElementsByTagName("body")[0].innerText)?true:false;
   if(hasInnerText)
      html_control.innerText=text;
   else 
      html_control.textContent=text; 
        
};

IXML.getInnerText=function(html_control)
{
   var hasInnerText = (document.getElementsByTagName("body")[0].innerText)?true:false;
   if(hasInnerText)
      return html_control.innerText;
   else if(html_control.textContent)
      return html_control.textContent; 
   else
      return "";      
};

if(window.XMLSerializer){
    /**
     * <p>Factory method to obtain the serialization of a DOM Node</p>
     * @returns the serialized Node as an XML string
     */
    IXML.serialize = function(oDoc){
        var s = null;
        if(oDoc){
            s = oDoc.innerHTML?oDoc.innerHTML:(new XMLSerializer()).serializeToString(oDoc);
        };
        return s;
    };
}else{
    if(IXML.getDomDocument && (IXML.getDomDocument("","foo", null)).xml){
        // see non-IE version
        IXML.serialize = function(oDoc) {
            var s = null;
            if(oDoc){
                s = oDoc.innerHTML?oDoc.innerHTML:oDoc.xml;
            };
            return s;
        };
        /**
         * Utility class to serialize DOM Node objects to XML strings
         * @constructor
         */
        XMLSerializer = function(){};
        /**
         * Serialize the given DOM Node to an XML string
         * @param oNode the DOM Node to serialize
         */
        XMLSerializer.prototype.serializeToString = function(oNode) {
            return oNode.xml;
        };
    };
};

/**
 * strips tags from a markup string
 * @param {string} s is stripped string
 * @type string
 */
IXML.stripTags = function (s) {
    return s.replace(/<[^>]+>/g,"");
};
/**
 * Deletes all child nodes of the given node
 * @argument{object} oNode is xml node need to empty
 */
IXML.clearChildNodes = function(oNode) {
    // need to check for firstChild due to opera 8  bug with hasChildNodes
    if(null==oNode){
      throw " node isn't exists"; 
    };
    while(oNode.firstChild){
        oNode.removeChild(oNode.firstChild);
    };
};

/**
 * <p> Copies the childNodes of nodeFrom to nodeTo</p>
 * <p> <b>Note:</b> The second object's original content is deleted before
 * the copy operation, unless you supply a true third parameter</p>
 * @argument{object} nodeFrom is xml node ,whose childNodes are copied to other xml node
 * @argument {object} nodeTo is xml node where the childNodes are copied.
 * @argument{boolean} bPreserveExisting is flag ,that  preserve the original content of nodeTo
 * <p><b>Note:</b> default is false
 */
IXML.copyChildNodes = function(nodeFrom, nodeTo, bPreserveExisting) {
    if((!nodeFrom) || (!nodeTo)){
        throw "Both source and destination nodes must be provided";
    };
    if(!bPreserveExisting){
        IXML.clearChildNodes(nodeTo);
    };
    var ownerDoc = nodeTo.nodeType == Node.DOCUMENT_NODE ? nodeTo : nodeTo.ownerDocument;
    var nodes = nodeFrom.childNodes;
    if(!_IXML_IS_IE) {
        if(ownerDoc.importNode) 
			for(var i=0;i < nodes.length;i++) {
				nodeTo.appendChild(ownerDoc.importNode(nodes[i], true));
			};
    }
    else{
        for(var i=0;i < nodes.length;i++) {
            nodeTo.appendChild(nodes[i].cloneNode(true));
        };
    };
};
/**
* @param {object} currNode is added xml element
* @param {object} nodeTo is a parent xml element 
*/
IXML.appendChild=function(currNode,nodeTo){
   var ownerDoc = nodeTo.nodeType == Node.DOCUMENT_NODE ? nodeTo : nodeTo.ownerDocument;
   if(!_IXML_IS_IE) {
      if(ownerDoc.importNode) 
         nodeTo.appendChild(ownerDoc.importNode(currNode,true)); 
   }
   else{
         nodeTo.appendChild(currNode.cloneNode(true));
   };
};
/**
* @param {object} currNode is inserted xml element
* @param {object} beforeNode is xml element 
*/
IXML.insertBefore=function(currNode,beforeNode){
   var ownerDoc = beforeNode.ownerDocument;
   var parent = IXML.getParentElement(beforeNode);
   if (parent==null) return null;
   if(!_IXML_IS_IE) {
      if(ownerDoc.importNode) 
         parent.insertBefore(ownerDoc.importNode(currNode,true),beforeNode); 
   }
   else{
        parent.insertBefore(currNode.cloneNode(true),beforeNode);
   };
};
/** Get context xml element ancestors collection by node name
* @param {object} node is context xml element
* @param {string} nodeNameFilter is name ancestor xml element
* @type collection
*/
IXML.getAncestors = function (node,nodeNameFilter)
{

var col = new Array();
if (node==null) return col;

var parent = IXML.getParentElement(node);
while (parent!=null)
	{
		if (nodeNameFilter!=null && parent.nodeName==nodeNameFilter)
			col.push(parent);
		else if (nodeNameFilter==null)
			col.push(parent);
			
		parent = IXML.getParentElement(parent)
			
	}
return col
};
/** Get parent xml element
* @param {object} node is context xml element
* @return parent xml element
* @type object
*/
IXML.getParentElement=function(node){
	try{
        try{
          if(node==null)
            throw "xml node not exists";
        }catch(e){
          alert("**error occured IXML.getParentElement***" + e.description);
          return null;
        }
        
        var parentNode = node.parentNode;
    	if(parentNode.nodeType!=Node.ELEMENT_NODE)
    	     IXML.getParentElement(parentNode);
    	else
    	   return parentNode;
	   }
	 catch(e)
     {
        
     }  
};
/** Get child xml elemet of context parent xml element
*   @param {object}node is xml or html element
*   @param {int}pos is child element position <p>
*    <b>Note:</b>start from 1
*   @return xml or html element
*   @type object    
*/
IXML.getChildElement=function(node,pos){
	if(null==node)return null;
	if(node.childNodes.length==null)return null;
	var is_xml = (node.innerHTML!=null)?false:true;
	var ind = pos-1;
    var childNode,childNodes;
    if(is_xml)
    {
      childNodes = node.selectNodes("./*");
      if(childNodes.length>0)       
       return childNodes[ind];
    }
    else
    {
      if(_IXML_IS_IE)
          return node.children[ind];
      else
      {
        childNodes = node.childNodes;
        var i,j=0;
        for(var i=0;i<childNodes.length;i++)
           {
              if(childNodes[i].nodeType==Node.ELEMENT_NODE)
                 {
                    if(j==ind)
                       return childNodes[i];
                       j++;
                 }  
           }
      }   
     
    }
     
    
           
    return null;
   
};
/** 
* @param {object} node is context xml element
* @return previous sibling for context xml element
* @type object
*/
IXML.getPreviousSibling = function(node)
{
	if(null==node)return null;
    node = node.previousSibling;
    if (node==null) return null;
    while (node.nodeType!=1)
          {
          node = node.previousSibling;
          if (node==null) return null
          }
       return node
};
/** 
* @param {object} node is context xml element
* @return next sibling for context xml element
* @type object
*/
IXML.getNextSibling = function(node)
{
    if(null==node)return null;
    node = node.nextSibling;
    if (node==null) return null;
    while (node.nodeType!=1)
          {
          node = node.nextSibling;
          if (node==null) return null
          }
         return node 
};

/**
* @param{object}
* @return trouth value
* @type bool
*/
IXML.hasChildElements = function(node){
   if(node==null)return false;
   var childs = node.childNodes;
   for(var i=0;i<childs.length;i++){
       if(childs[i].nodeType==1)return true;
   }
   return false;
};
/** 
* @param {object} node is xml element or html control
* @param {string} name is container node name
* @return container for context xml element or html control
* @type object
*/
IXML.getContainer=function(node,name)
{
   if(node==null)return;
   var container = node;
   var contextName = (container.nodeName)?container.nodeName.toLowerCase():container.tagName.toLowerCase();
   while(contextName  != name.toLowerCase())
    {
	
      container = IXML.getParentElement(container);
      if (container==null)
           break; 
      else{     
          contextName = (container.nodeName)?container.nodeName.toLowerCase():container.tagName.toLowerCase();
      }
      
    }
      return container        
};

/* set attribute to container node
* @param {object} node is current xml element or html control
* @param {string} tagName is name of ancestor's tag
* @param {string} attrName is name of attribute
* @param {string} attrValue is value of the attribute
*/

IXML.setContainerAttribute=function(node,nodeName,attrName,attrValue)
 {
    if(node==null)return;
    if(node.nodeName==nodeName){
        node.setAttribute(attrName,attrValue);
        return;
    }    
    else if(node.tagName==nodeName){
        node.setAttribute(attrName,attrValue);
         return;
     }   
    else
     {
        IXML.setContainerAttribute(IXML.getParentElement(node),nodeName,attrName,attrValue);
     }      
 };

/* set attribute to all ancestore elements
* @param {object} node is current xml element or html control
* @param {string} attrName is name of attribute
* @param {string} attrValue is value of the attribute
*/

IXML.set_selfancestorsAttribute = function(node,attr_name,attr_value)
{
   if(node){
        node.setAttribute(attr_name,attr_value);
        node = IXML.getParentElement(node);
         if(node){
           IXML.set_selfancestorsAttribute(node,attr_name,attr_value)
            
         }
  }      
    
};
/**
*removing unneeded attributes
*@param {collection} nodeset is xml nodeset 
*@param {string} attr_name is attribute name;
*@param {string} attr_value is attribute value (optional) 
*/
IXML.removeAttribute = function(nodeset,attr_name,attr_value)
{
   if(nodeset)
   {
      if(nodeset.length>0)
      {
         var i;
         if(attr_value && attr_value!="")
         {
             for(var i=0;i<nodeset.length;i++)
             {
                if(nodeset[i].getAttribute(attr_name)==attr_value)
                   nodeset[i].removeAttribute(attr_name);
             }
         }
         else
         {
            for(var i=0;i<nodeset.length;i++)nodeset[i].removeAttribute(attr_name);
             
         }
      }
   } 
  
    
};


/**set attribute to collection xml nodes
*@param {collection} nodeset is xml nodeset 
*@param {string} attr_name is attribute name;
*@param {string} attr_value is attribute value (optional) 
*/
IXML.setAttribute = function(nodeset,attr_name,attr_value)
{
   if(nodeset)
   {
      if(nodeset.length>0)
      {
         var i;
         if(attr_name!=null && attr_value!=null)
         {
             for(var i=0;i<nodeset.length;i++)
             {
               nodeset[i].setAttribute(attr_name,attr_value);
             }
         }
        
      }
   } 
  
    
};

 //==========================================
// Common stuff
//==========================================
if(!window.DOMParser){
    if(_IXML_IS_SAFARI){
        /*
         * DOMParser is a utility class, used to construct DOMDocuments from XML strings
         * @constructor
         */
        DOMParser = function() { };
        /**
        * Construct a new DOM Document from the given XMLstring
        * @param sXml the given XML string
        * @param contentType the content type of the document the given string represents (one of text/xml, application/xml, application/xhtml+xml).
        * @return a new DOM Document from the given XML string
        */
        DOMParser.prototype.parseFromString = function(sXml, contentType){
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.open("GET", "data:text/xml;charset=utf-8," + encodeURIComponent(sXml), false);
            xmlhttp.send(null);
            return xmlhttp.responseXML;
        };
    }else if(IXML.getDomDocument && IXML.getDomDocument() && IXML.getDomDocument(null, "bar").xml){
        DOMParser = function() { };
        DOMParser.prototype.parseFromString = function(sXml, contentType){
            var doc = IXML.getDomDocument();
            doc.loadXML(sXml);
            return doc;
        };
    };
};


if(_IXML_HAS_DOM_FEATURE && document.implementation.hasFeature("XPath", "3.0")){

     function XmlNodeList(i){
        this.length = i;
    };

    XmlNodeList.prototype.item = function(i) {
        return (i < 0 || i >= this.length)?null:this[i];
    };

    /* * <p>Emulate IE's expr property
    * (Here the XmlNodeList object is given as the result of selectNodes).</p>
    * @returns the XPath expression passed to selectNodes that resulted in
    *          this XmlNodeList
    */
    XmlNodeList.prototype.expr = "";
    /** dummy, used to accept IE stuff without throwing errors */
    if(window.XMLDocument && (!XMLDocument.prototype.setProperty)){
        XMLDocument.prototype.setProperty  = function(x,y){};
    };

     /**
    * <p>Programmatically control namespace URI/prefix mappings for XPath
    * queries.</p>
    * <p>This method comes especially handy when used to apply XPath queries
    * on XML documents with a default namespace, as there is no other way
    * of mapping that to a prefix.</p>
    * <p>Using no namespace prefix in DOM Level 3 XPath queries, implies you
    * are looking for elements in the null namespace. If you need to look
    * for nodes in the default namespace, you need to map a prefix to it
    * first like:</p>
    * <pre>IXML.setXpathNamespaces(oDoc, xmlns:myprefix=&amp;aposhttp://mynsURI&amp;apos&quot;);</pre>
    * <p><b>Note 1 </b>: Use this method only if the source document features
    * a default namespace (without a prefix), otherwise just use IE's setProperty
    * (moz will rezolve non-default namespaces by itself). You will need to map that
    * namespace to a prefix for queries to work.</p>
    * <p><b>Note 2 </b>: This method calls IE's setProperty method to set the
    * appropriate namespace-prefix mappings, so you dont have to do that.</p>
    * @param oDoc The target XMLDocument to set the namespace mappings for.
    * @param sNsSet A whilespace-seperated list of namespace declarations as
    *            those would appear in an XML document. E.g.:
    *            <code>&quot;xmlns:xhtml=&apos;http://www.w3.org/1999/xhtml&apos;
    * xmlns:&apos;http://www.w3.org/1999/XSL/Transform&apos;&quot;</code>
    * @throws An error if the format of the given namespace declarations is bad.
    */
    IXML.setXpathNamespaces = function(oDoc, sNsSet) {

        oDoc._ixml_useCustomResolver = true;
        var namespaces = sNsSet.indexOf(" ")>-1?sNsSet.split(" "):new Array(sNsSet);
        oDoc._ixml_xpathNamespaces = new Array(namespaces.length);
        for(var i=0;i < namespaces.length;i++){
            var ns = namespaces[i];
            var colonPos = ns.indexOf(":");
            var assignPos = ns.indexOf("=");
            if(colonPos > 0 && assignPos > colonPos+1){
                var prefix = ns.substring(colonPos+1, assignPos);
                var uri = ns.substring(assignPos+2, ns.length-1);
                oDoc._ixml_xpathNamespaces[prefix] = uri;
            }else{
                throw "Bad format on namespace declaration(s) given";
            };
        };
    };
     /**
    * @private Flag to control whether a custom namespace resolver should
    *          be used, set to true by IXML.setXpathNamespaces
    */
    XMLDocument.prototype._ixml_useCustomResolver = false;
    /** @private */
    XMLDocument.prototype._ixml_xpathNamespaces = new Array();
    /**
    * <p>Extends the XMLDocument to emulate IE's selectNodes.</p>
    * @argument sExpr the XPath expression to use
    * @argument contextNode this is for internal use only by the same
    *           method when called on Elements
    * @returns the result of the XPath search as a XmlNodeList
    * @throws An error if no namespace URI is found for the given prefix.
    */
    XMLDocument.prototype.selectNodes = function(sExpr, contextNode){
        var nsDoc = this;
        var nsresolver = this._ixml_useCustomResolver
        ? function(prefix){
            var s = nsDoc._ixml_xpathNamespaces[prefix];
            if(s)return s;
            else throw "No namespace URI found for prefix: '" + prefix+"'";
            }
        : this.createNSResolver(this.documentElement);
            var oResult = this.evaluate(sExpr,
                    (contextNode?contextNode:this),
                    nsresolver,
                    XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
        var nodeList = new XmlNodeList(oResult.snapshotLength);
        nodeList.expr = sExpr;
        for(var i=0;i<nodeList.length;i++)
            nodeList[i] = oResult.snapshotItem(i);
        return nodeList;
    };


   /**
    * <p>Extends the Element to emulate IE's selectNodes</p>
    * @argument sExpr the XPath expression to use
    * @returns the result of the XPath search as an XmlNodeList
    * @throws An
    *             error if invoked on an HTML Element as this is only be
    *             available to XML Elements.
    */
    Element.prototype.selectNodes = function(sExpr){
        var doc = this.ownerDocument;
        if(doc.selectNodes)
            return doc.selectNodes(sExpr, this);
        else
            throw "Method selectNodes is only supported by XML Elements";
    };
    /**
    * <p>Extends the XMLDocument to emulate IE's selectSingleNode.</p>
    * @argument sExpr the XPath expression to use
    * @argument contextNode this is for internal use only by the same
    *           method when called on Elements
    * @returns the result of the XPath search as an XmlNodeList
    */
    XMLDocument.prototype.selectSingleNode = function(sExpr, contextNode){
	
        var ctx = contextNode?contextNode:null;
        sExpr = "("+sExpr+")[1]";
        var nodeList = this.selectNodes(sExpr, ctx);
        if(nodeList.length > 0)
            return nodeList.item(0);
        else
            return null;
    };

    /**
    * <p>Extends the Element to emulate IE's selectSingleNode.</p>
    * @argument sExpr the XPath expression to use
    * @returns the result of the XPath search as an XmlNodeList
    * @throws An error if invoked on an HTML Element as this is only be
    *             available to XML Elements.
    */
   Element.prototype.selectSingleNode = function(sExpr){
	
        var doc = this.ownerDocument;
        if(doc.selectSingleNode)
            return doc.selectSingleNode(sExpr, this);
        else
            throw "Method selectNodes is only supported by XML Elements";
    };
    
   
    
    IXML.IS_ENABLED_SELECT_NODES = true;



}
